image: node

stages:
    - build
    - test
    - deploy staging
    - deploy production
    - production tests  
    - cache  

cache:
    key: ${CI_COMMIT_REF_SLUG}
    policy: pull
    paths:
        - node_modules/

variables:
    STAGING_DOMAIN: quaint-lead-staging.surge.sh
    PRODUCTION_DOMAIN: quaint-lead.surge.sh

build website:
    stage: build
    script:
        - echo $CI_COMMIT_SHORT_SHA
        - npm install
        - npm install -g gatsby-cli
        - gatsby build
        - sed -i "s/%%VERSION%%/$CI_COMMIT_SHORT_SHA/" ./public/index.html
    artifacts:
        paths:
            - ./public

test artifact:
    image: alpine
    stage: test
    script:
        - grep -q "Gatsby" ./public/index.html
        
test website:
    stage: test
    script:
        - npm install
        - npm install -g gatsby-cli
        - gatsby serve & 
        - sleep 3        
        - curl "http://localhost:9000" | tac | tac | grep -q "Gatsby"

deploy staging:
    stage: deploy staging
    environment:
        name: staging
        url: http://$STAGING_DOMAIN
    only:
        - master
    script:
        - npm install --global surge
        - surge --project ./public --domain $STAGING_DOMAIN

deploy production:
    stage: deploy production
    environment:
        name: production
        url: http://$PRODUCTION_DOMAIN
    only:
        - master
    script:
        - npm install --global surge
        - surge --project ./public --domain $PRODUCTION_DOMAIN

production tests:
    image: alpine
    stage: production tests
    only:
        - master
    script:
        - apk add curl
        - curl "http://$PRODUCTION_DOMAIN" | tac | tac | grep -q "Gatsby"
        - curl "http://$PRODUCTION_DOMAIN" | tac | tac | grep -q "$CI_COMMIT_SHORT_SHA"
        
update cache:
    stage: cache
    cache:
        key: ${CI_COMMIT_REF_SLUG}
        policy: push
        paths:
            - node_modules/
    only:
        - schedules
    script:
        - npm install
